Index: LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90	(revision 2298)
+++ LMDZ5/branches/testing/libf/dyn3dmem/gcm.F90	(revision 2298)
@@ -0,0 +1,500 @@
+! $Id: $
+
+PROGRAM gcm
+
+#ifdef CPP_IOIPSL
+  USE IOIPSL
+#endif
+
+  USE mod_const_mpi, ONLY: init_const_mpi
+  USE parallel_lmdz
+  USE infotrac
+#ifdef CPP_PHYS
+  USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
+#endif
+  USE mod_hallo
+  USE Bands
+  USE filtreg_mod
+  USE control_mod
+
+#ifdef INCA
+  ! Only INCA needs these informations (from the Earth's physics)
+  USE indice_sol_mod
+  USE mod_phys_lmdz_omp_data, ONLY: klon_omp 
+#endif
+
+#ifdef CPP_PHYS
+  !      USE mod_grid_phy_lmdz
+  !      USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
+  !      USE dimphy
+  !      USE comgeomphy
+#endif
+  IMPLICIT NONE
+
+  !      ......   Version  du 10/01/98    ..........
+
+  !             avec  coordonnees  verticales hybrides 
+  !   avec nouveaux operat. dissipation * ( gradiv2,divgrad2,nxgraro2 )
+
+  !=======================================================================
+  !
+  !   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+  !   -------
+  !
+  !   Objet:
+  !   ------
+  !
+  !   GCM LMD nouvelle grille
+  !
+  !=======================================================================
+  !
+  !  ... Dans inigeom , nouveaux calculs pour les elongations  cu , cv
+  !      et possibilite d'appeler une fonction f(y)  a derivee tangente
+  !      hyperbolique a la  place de la fonction a derivee sinusoidale.
+  !  ... Possibilite de choisir le schema pour l'advection de
+  !        q  , en modifiant iadv dans traceur.def  (MAF,10/02) .
+  !
+  !      Pour Van-Leer + Vapeur d'eau saturee, iadv(1)=4. (F.Codron,10/99)
+  !      Pour Van-Leer iadv=10
+  !
+  !-----------------------------------------------------------------------
+  !   Declarations:
+  !   -------------
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comdissnew.h"
+  include "comvert.h"
+  include "comgeom.h"
+  include "logic.h"
+  include "temps.h"
+  include "ener.h"
+  include "description.h"
+  include "serre.h"
+  !include "com_io_dyn.h"
+  include "iniprint.h"
+  include "tracstoke.h"
+
+#ifdef INCA
+  ! Only INCA needs these informations (from the Earth's physics)
+  !include "indicesol.h"
+#endif
+
+  REAL zdtvr
+
+  !   variables dynamiques
+  REAL,ALLOCATABLE,SAVE  :: vcov(:,:),ucov(:,:) ! vents covariants
+  REAL,ALLOCATABLE,SAVE  :: teta(:,:)     ! temperature potentielle 
+  REAL, ALLOCATABLE,SAVE :: q(:,:,:)      ! champs advectes
+  REAL,ALLOCATABLE,SAVE  :: ps(:)         ! pression  au sol
+  !      REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
+  REAL,ALLOCATABLE,SAVE  :: masse(:,:)    ! masse d'air
+  REAL,ALLOCATABLE,SAVE  :: phis(:)       ! geopotentiel au sol
+  !      REAL phi(ip1jmp1,llm)                  ! geopotentiel
+  !      REAL w(ip1jmp1,llm)                    ! vitesse verticale
+
+  ! variables dynamiques intermediaire pour le transport
+
+  !   variables pour le fichier histoire
+  REAL dtav      ! intervalle de temps elementaire
+
+  REAL time_0
+
+  LOGICAL lafin
+
+  real time_step, t_wrt, t_ops
+
+  !+jld variables test conservation energie
+  !      REAL ecin(ip1jmp1,llm),ecin0(ip1jmp1,llm)
+  !     Tendance de la temp. potentiel d (theta)/ d t due a la 
+  !     tansformation d'energie cinetique en energie thermique
+  !     cree par la dissipation
+  !      REAL dhecdt(ip1jmp1,llm)
+  !      REAL vcont(ip1jm,llm),ucont(ip1jmp1,llm)
+  !      REAL      d_h_vcol, d_qt, d_qw, d_ql, d_ec
+  !      CHARACTER (len=15) :: ztit
+  !-jld 
+
+
+  character (len=80) :: dynhist_file, dynhistave_file
+  character (len=20) :: modname
+  character (len=80) :: abort_message
+  ! locales pour gestion du temps
+  INTEGER :: an, mois, jour
+  REAL :: heure
+
+
+  !-----------------------------------------------------------------------
+  !   Initialisations:
+  !   ----------------
+
+  abort_message = 'last timestep reached'
+  modname = 'gcm'
+  descript = 'Run GCM LMDZ'
+  lafin    = .FALSE.
+  dynhist_file = 'dyn_hist'
+  dynhistave_file = 'dyn_hist_ave'
+
+
+
+  !----------------------------------------------------------------------
+  !  lecture des fichiers gcm.def ou run.def
+  !  ---------------------------------------
+  !
+  CALL conf_gcm( 99, .TRUE. )
+  if (mod(iphysiq, iperiod) /= 0) call abort_gcm("conf_gcm", &
+       "iphysiq must be a multiple of iperiod", 1)
+  !
+  !
+  !------------------------------------
+  !   Initialisation partie parallele
+  !------------------------------------
+  CALL init_const_mpi
+
+  call init_parallel
+  call Read_Distrib
+
+#ifdef CPP_PHYS
+  CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
+  !#endif
+  !      CALL set_bands
+  !#ifdef CPP_PHYS
+  CALL Init_interface_dyn_phys
+#endif
+  CALL barrier
+
+  CALL set_bands
+  if (mpi_rank==0) call WriteBands
+  call Set_Distrib(distrib_caldyn)
+
+  !$OMP PARALLEL
+  call Init_Mod_hallo
+  !$OMP END PARALLEL
+
+  !#ifdef CPP_PHYS
+  !c$OMP PARALLEL
+  !      call InitComgeomphy ! now done in iniphysiq
+  !c$OMP END PARALLEL 
+  !#endif
+
+  !-----------------------------------------------------------------------
+  !   Choix du calendrier
+  !   -------------------
+
+  !      calend = 'earth_365d'
+
+#ifdef CPP_IOIPSL
+  if (calend == 'earth_360d') then
+     call ioconf_calendar('360d')
+     write(lunout,*)'CALENDRIER CHOISI: Terrestre a 360 jours/an'
+  else if (calend == 'earth_365d') then
+     call ioconf_calendar('noleap')
+     write(lunout,*)'CALENDRIER CHOISI: Terrestre a 365 jours/an'
+  else if (calend == 'gregorian') then
+     call ioconf_calendar('gregorian')
+     write(lunout,*)'CALENDRIER CHOISI: Terrestre bissextile'
+  else
+     abort_message = 'Mauvais choix de calendrier'
+     call abort_gcm(modname,abort_message,1)
+  endif
+#endif
+
+  IF (type_trac == 'inca') THEN
+#ifdef INCA
+     call init_const_lmdz( &
+          nbtr,anneeref,dayref, &
+          iphysiq,day_step,nday,  &
+          nbsrf, is_oce,is_sic, &
+          is_ter,is_lic, calend)
+
+     call init_inca_para( &
+          iim,jjm+1,llm,klon_glo,mpi_size, &
+          distrib_phys,COMM_LMDZ)
+#endif
+  END IF
+
+  !-----------------------------------------------------------------------
+  !   Initialisation des traceurs
+  !   ---------------------------
+  !  Choix du nombre de traceurs et du schema pour l'advection
+  !  dans fichier traceur.def, par default ou via INCA
+  call infotrac_init
+
+  ! Allocation de la tableau q : champs advectes   
+  ALLOCATE(ucov(ijb_u:ije_u,llm))
+  ALLOCATE(vcov(ijb_v:ije_v,llm))
+  ALLOCATE(teta(ijb_u:ije_u,llm))
+  ALLOCATE(masse(ijb_u:ije_u,llm))
+  ALLOCATE(ps(ijb_u:ije_u))
+  ALLOCATE(phis(ijb_u:ije_u))
+  ALLOCATE(q(ijb_u:ije_u,llm,nqtot))
+
+  !-----------------------------------------------------------------------
+  !   Lecture de l'etat initial :
+  !   ---------------------------
+
+  !  lecture du fichier start.nc
+  if (read_start) then
+     ! we still need to run iniacademic to initialize some
+     ! constants & fields, if we run the 'newtonian' or 'SW' cases:
+     if (iflag_phys.ne.1) then
+        CALL iniacademic_loc(vcov,ucov,teta,q,masse,ps,phis,time_0)
+     endif
+
+     !        if (planet_type.eq."earth") then
+     ! Load an Earth-format start file
+     CALL dynetat0_loc("start.nc",vcov,ucov, &
+          teta,q,masse,ps,phis, time_0)
+     !        endif ! of if (planet_type.eq."earth")
+
+     !       write(73,*) 'ucov',ucov
+     !       write(74,*) 'vcov',vcov
+     !       write(75,*) 'teta',teta
+     !       write(76,*) 'ps',ps
+     !       write(77,*) 'q',q
+
+  endif ! of if (read_start)
+
+  ! le cas echeant, creation d un etat initial
+  IF (prt_level > 9) WRITE(lunout,*) &
+       'GCM: AVANT iniacademic AVANT AVANT AVANT AVANT'
+  if (.not.read_start) then
+     CALL iniacademic_loc(vcov,ucov,teta,q,masse,ps,phis,time_0)
+  endif
+
+  !-----------------------------------------------------------------------
+  !   Lecture des parametres de controle pour la simulation :
+  !   -------------------------------------------------------
+  !  on recalcule eventuellement le pas de temps
+
+  IF(MOD(day_step,iperiod).NE.0) THEN
+     abort_message =  &
+          'Il faut choisir un nb de pas par jour multiple de iperiod'
+     call abort_gcm(modname,abort_message,1)
+  ENDIF
+
+  IF(MOD(day_step,iphysiq).NE.0) THEN
+     abort_message =  &
+          'Il faut choisir un nb de pas par jour multiple de iphysiq'
+     call abort_gcm(modname,abort_message,1)
+  ENDIF
+
+  zdtvr    = daysec/REAL(day_step)
+  IF(dtvr.NE.zdtvr) THEN
+     WRITE(lunout,*) &
+          'WARNING!!! changement de pas de temps',dtvr,'>',zdtvr
+  ENDIF
+
+  !
+  ! on remet le calendrier \`a zero si demande
+  !
+  IF (start_time /= starttime) then
+     WRITE(lunout,*)' GCM: Attention l''heure de depart lue dans le' &
+          ,' fichier restart ne correspond pas a celle lue dans le run.def'
+     IF (raz_date == 1) then
+        WRITE(lunout,*)'Je prends l''heure lue dans run.def'
+        start_time = starttime
+     ELSE
+        WRITE(lunout,*)'Je m''arrete'
+        CALL abort
+     ENDIF
+  ENDIF
+  IF (raz_date == 1) THEN
+     annee_ref = anneeref
+     day_ref = dayref
+     day_ini = dayref
+     itau_dyn = 0
+     itau_phy = 0
+     time_0 = 0.
+     write(lunout,*) &
+          'GCM: On reinitialise a la date lue dans gcm.def'
+  ELSE IF (annee_ref .ne. anneeref .or. day_ref .ne. dayref) THEN
+     write(lunout,*) &
+          'GCM: Attention les dates initiales lues dans le fichier'
+     write(lunout,*) &
+          ' restart ne correspondent pas a celles lues dans '
+     write(lunout,*)' gcm.def'
+     write(lunout,*)' annee_ref=',annee_ref," anneeref=",anneeref
+     write(lunout,*)' day_ref=',day_ref," dayref=",dayref
+     write(lunout,*)' Pas de remise a zero'
+  ENDIF
+  !      if (annee_ref .ne. anneeref .or. day_ref .ne. dayref) then
+  !        write(lunout,*)
+  !     .  'GCM: Attention les dates initiales lues dans le fichier'
+  !        write(lunout,*)
+  !     .  ' restart ne correspondent pas a celles lues dans '
+  !        write(lunout,*)' gcm.def'
+  !        write(lunout,*)' annee_ref=',annee_ref," anneeref=",anneeref
+  !        write(lunout,*)' day_ref=',day_ref," dayref=",dayref
+  !        if (raz_date .ne. 1) then
+  !          write(lunout,*)
+  !     .    'GCM: On garde les dates du fichier restart'
+  !        else
+  !          annee_ref = anneeref
+  !          day_ref = dayref
+  !          day_ini = dayref
+  !          itau_dyn = 0
+  !          itau_phy = 0
+  !          time_0 = 0.
+  !          write(lunout,*)
+  !     .   'GCM: On reinitialise a la date lue dans gcm.def'
+  !        endif
+  !      ELSE
+  !        raz_date = 0
+  !      endif
+
+#ifdef CPP_IOIPSL
+  mois = 1
+  heure = 0.
+  call ymds2ju(annee_ref, mois, day_ref, heure, jD_ref)
+  jH_ref = jD_ref - int(jD_ref)
+  jD_ref = int(jD_ref)
+
+  call ioconf_startdate(INT(jD_ref), jH_ref)
+
+  write(lunout,*)'DEBUG'
+  write(lunout,*)'annee_ref, mois, day_ref, heure, jD_ref'
+  write(lunout,*)annee_ref, mois, day_ref, heure, jD_ref
+  call ju2ymds(jD_ref+jH_ref,an, mois, jour, heure)
+  write(lunout,*)'jD_ref+jH_ref,an, mois, jour, heure'
+  write(lunout,*)jD_ref+jH_ref,an, mois, jour, heure
+#else
+  ! Ehouarn: we still need to define JD_ref and JH_ref
+  ! and since we don't know how many days there are in a year
+  ! we set JD_ref to 0 (this should be improved ...)
+  jD_ref=0
+  jH_ref=0
+#endif
+
+  if (iflag_phys.eq.1) then
+     ! these initialisations have already been done (via iniacademic)
+     ! if running in SW or Newtonian mode
+     !-----------------------------------------------------------------------
+     !   Initialisation des constantes dynamiques :
+     !   ------------------------------------------
+     dtvr = zdtvr
+     CALL iniconst
+
+     !-----------------------------------------------------------------------
+     !   Initialisation de la geometrie :
+     !   --------------------------------
+     CALL inigeom
+
+     !-----------------------------------------------------------------------
+     !   Initialisation du filtre :
+     !   --------------------------
+     CALL inifilr
+  endif ! of if (iflag_phys.eq.1)
+  !
+  !-----------------------------------------------------------------------
+  !   Initialisation de la dissipation :
+  !   ----------------------------------
+
+  CALL inidissip( lstardis, nitergdiv, nitergrot, niterh   , &
+       tetagdiv, tetagrot , tetatemp, vert_prof_dissip)
+
+  !-----------------------------------------------------------------------
+  !   Initialisation de la physique :
+  !   -------------------------------
+  IF ((iflag_phys==1).or.(iflag_phys>=100)) THEN
+     ! Physics:
+#ifdef CPP_PHYS
+     CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys, &
+          rlatu,rlonv,aire,cu,cv,rad,g,r,cpp, &
+          iflag_phys)
+#endif
+  ENDIF ! of IF ((iflag_phys==1).or.(iflag_phys>=100))
+
+
+  !-----------------------------------------------------------------------
+  !   Initialisation des dimensions d'INCA :
+  !   --------------------------------------
+  IF (type_trac == 'inca') THEN
+     !$OMP PARALLEL
+#ifdef INCA
+     CALL init_inca_dim(klon_omp,llm,iim,jjm, &
+          rlonu,rlatu,rlonv,rlatv)
+#endif
+     !$OMP END PARALLEL
+  END IF
+
+  !-----------------------------------------------------------------------
+  !   Initialisation des I/O :
+  !   ------------------------
+
+
+  if (nday>=0) then
+     day_end = day_ini + nday
+  else
+     day_end = day_ini - nday/day_step
+  endif
+
+  WRITE(lunout,300)day_ini,day_end
+300 FORMAT('1'/,15x,'run du jour',i7,2x,'au jour',i7//)
+
+#ifdef CPP_IOIPSL
+  call ju2ymds(jD_ref + day_ini - day_ref, an, mois, jour, heure)
+  write (lunout,301)jour, mois, an
+  call ju2ymds(jD_ref + day_end - day_ref, an, mois, jour, heure)
+  write (lunout,302)jour, mois, an
+301 FORMAT('1'/,15x,'run du ', i2,'/',i2,'/',i4)
+302 FORMAT('1'/,15x,'    au ', i2,'/',i2,'/',i4)
+#endif
+
+  !      if (planet_type.eq."earth") then
+  ! Write an Earth-format restart file
+  CALL dynredem0_loc("restart.nc", day_end, phis)
+  !      endif
+
+  ecripar = .TRUE.
+
+#ifdef CPP_IOIPSL
+  time_step = zdtvr
+  IF (mpi_rank==0) then
+     if (ok_dyn_ins) then
+        ! initialize output file for instantaneous outputs
+        ! t_ops = iecri * daysec ! do operations every t_ops
+        t_ops =((1.0*iecri)/day_step) * daysec  
+        t_wrt = daysec ! iecri * daysec ! write output every t_wrt
+        t_wrt = daysec ! iecri * daysec ! write output every t_wrt
+        CALL inithist(day_ref,annee_ref,time_step, &
+             t_ops,t_wrt)
+     endif
+
+     IF (ok_dyn_ave) THEN 
+        ! initialize output file for averaged outputs
+        t_ops = iperiod * time_step ! do operations every t_ops
+        t_wrt = periodav * daysec   ! write output every t_wrt
+        CALL initdynav_loc(day_ref,annee_ref,time_step,t_ops,t_wrt)
+     END IF
+  ENDIF
+  dtav = iperiod*dtvr/daysec
+#endif
+  ! #endif of #ifdef CPP_IOIPSL
+
+  !  Choix des frequences de stokage pour le offline
+  !      istdyn=day_step/4     ! stockage toutes les 6h=1jour/4
+  !      istdyn=day_step/12     ! stockage toutes les 2h=1jour/12
+  istdyn=day_step/4     ! stockage toutes les 6h=1jour/12
+  istphy=istdyn/iphysiq     
+
+
+  !
+  !-----------------------------------------------------------------------
+  !   Integration temporelle du modele :
+  !   ----------------------------------
+
+  !       write(78,*) 'ucov',ucov
+  !       write(78,*) 'vcov',vcov
+  !       write(78,*) 'teta',teta
+  !       write(78,*) 'ps',ps
+  !       write(78,*) 'q',q
+
+  !$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logici/,/logicl/)
+  CALL leapfrog_loc(ucov,vcov,teta,ps,masse,phis,q,time_0)
+  !$OMP END PARALLEL
+
+  !      OPEN(unit=5487,file='ok_lmdz',status='replace')
+  !      WRITE(5487,*) 'ok_lmdz'
+  !      CLOSE(5487)
+END PROGRAM gcm
Index: LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3dmem/guide_loc_mod.F90	(revision 2298)
@@ -87,4 +87,5 @@
 ! Lecture des parametres:  
 ! ---------------------------------------------
+    call ini_getparam("nudging_parameters_out.txt")
 ! Variables guidees
     CALL getpar('guide_u',.true.,guide_u,'guidage de u')
@@ -159,4 +160,6 @@
     CALL getpar('guide_2D',.false.,guide_2D,'fichier guidage lat-P')
 
+    call fin_getparam
+    
 ! ---------------------------------------------
 ! Determination du nombre de niveaux verticaux
Index: LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90	(revision 2298)
@@ -7,5 +7,6 @@
   use exner_hyb_m, only: exner_hyb
   use exner_milieu_m, only: exner_milieu
-  USE infotrac, ONLY : nqtot
+  USE infotrac, ONLY: nqtot,niso_possibles,ok_isotopes,iqpere,ok_iso_verif,tnat,alpha_ideal, &
+        & iqiso,phase_num,iso_indnum,iso_num,zone_num
   USE control_mod, ONLY: day_step,planet_type
   USE parallel_lmdz, ONLY: ijb_u, ije_u, ijb_v, ije_v
@@ -110,5 +111,5 @@
   ztot0      = 0.
   stot0      = 0.
-  ang0       = 0.
+  ang0       = 0.      
 
   if (llm == 1) then
@@ -269,12 +270,32 @@
         if (planet_type=="earth") then
            ! Earth: first two tracers will be water
+
            do i=1,nqtot
               if (i == 1) q(ijb_u:ije_u,:,i)=1.e-10
               if (i == 2) q(ijb_u:ije_u,:,i)=1.e-15
               if (i.gt.2) q(ijb_u:ije_u,:,i)=0.
+
+              ! CRisi: init des isotopes
+              ! distill de Rayleigh très simplifiée
+              if (ok_isotopes) then
+                if ((iso_num(i).gt.0).and.(zone_num(i).eq.0)) then          
+                   q(ijb_u:ije_u,:,i)=q(ijb_u:ije_u,:,iqpere(i))       &
+      &                  *tnat(iso_num(i))                             &
+      &                  *(q(ijb_u:ije_u,:,iqpere(i))/30.e-3)                              &
+     &                   **(alpha_ideal(iso_num(i))-1)
+                endif                
+                if ((iso_num(i).gt.0).and.(zone_num(i).eq.1)) then
+                  q(ijb_u:ije_u,:,i)=q(ijb_u:ije_u,:,iqiso(iso_indnum(i),phase_num(i)))
+                endif
+              endif !if (ok_isotopes) then
+
            enddo
         else
            q(ijb_u:ije_u,:,:)=0
         endif ! of if (planet_type=="earth")
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'iniacademic_loc')
+        endif !if (ok_iso_verif) then
 
         ! add random perturbation to temperature
Index: LMDZ5/branches/testing/libf/dyn3dmem/integrd_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/integrd_loc.F	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3dmem/integrd_loc.F	(revision 2298)
@@ -11,4 +11,5 @@
       USE write_field
       USE integrd_mod
+      USE infotrac, ONLY: ok_iso_verif ! ajout CRisi
       IMPLICIT NONE
 
@@ -86,5 +87,7 @@
       INTEGER :: ierr
 
+      !write(*,*) 'integrd 88: entree, nq=',nq
 c-----------------------------------------------------------------------
+
 c$OMP BARRIER     
       if (pole_nord) THEN
@@ -125,6 +128,8 @@
       DO 2 ij = ijb,ije
        pscr (ij)    = ps0(ij)
-       ps (ij)      = psm1(ij) + dt * dp(ij)
+       ps (ij)      = psm1(ij) + dt * dp(ij)     
+
    2  CONTINUE
+
 c$OMP END DO  
 c$OMP BARRIER
@@ -159,4 +164,5 @@
 c$OMP END MASTER
 c$OMP BARRIER
+        !write(*,*) 'integrd 170'
       IF (.NOT. Checksum_all) THEN
         call WriteField_v('int_vcov',vcov)
@@ -188,4 +194,5 @@
        
 c
+        !write(*,*) 'integrd 200'
 C$OMP MASTER
       if (pole_nord) THEN
@@ -214,4 +221,5 @@
 c$OMP END MASTER
 c$OMP BARRIER
+      !write(*,*) 'integrd 217'  
 c
 c  ... Calcul  de la nouvelle masse d'air au dernier temps integre t+1 ...
@@ -219,4 +227,5 @@
 
       CALL pression_loc ( ip1jmp1, ap, bp, ps, p )
+
 c$OMP BARRIER
       CALL massdair_loc (     p  , masse         )
@@ -276,4 +285,5 @@
 c
 c
+        !write(*,*) 'integrd 291'
       IF (pole_nord) THEN
        
@@ -334,8 +344,19 @@
            ENDDO
           ENDDO
+          
 c$OMP END DO NOWAIT
 c$OMP BARRIER
 
-          CALL qminimum_loc( q, nq, deltap )
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb,ije,'integrd 342')
+        endif !if (ok_iso_verif) then
+
+        !write(*,*) 'integrd 341'
+        CALL qminimum_loc( q, nq, deltap )
+        !write(*,*) 'integrd 343'
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb,ije,'integrd 346')
+        endif !if (ok_iso_verif) then
 c
 c    .....  Calcul de la valeur moyenne, unique  aux poles pour  q .....
@@ -387,4 +408,8 @@
       
       ENDIF
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb,ije,'integrd 409')
+        endif !if (ok_iso_verif) then
       
 ! Ehouarn: forget about finvmaold
@@ -404,4 +429,5 @@
 
 15    continue
+          !write(*,*) 'integrd 410'
 
 c$OMP DO SCHEDULE(STATIC)
Index: LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 2298)
@@ -200,4 +200,8 @@
       LOGICAL, SAVE :: firstcall=.TRUE.
       TYPE(distrib),SAVE :: new_dist
+
+      if (ok_iso_verif) then
+         call check_isotopes(q0,ijb_u,ije_u,'leapfrog204: debut')
+      endif !if (ok_iso_verif) then
       
 c$OMP MASTER
@@ -219,4 +223,8 @@
       itaufinp1 = itaufin +1
 
+      if (ok_iso_verif) then
+        call check_isotopes(q0,ijb_u,ije_u,'leapfrog 226')
+      endif !if (ok_iso_verif) then
+
       itau = 0
       physic=.true.
@@ -231,4 +239,8 @@
       phis=phis0
       q=q0
+
+      if (ok_iso_verif) then
+        call check_isotopes(q,ijb_u,ije_u,'leapfrog 239')
+      endif !if (ok_iso_verif) then
       
 !      iday = day_ini+itau/day_step
@@ -296,5 +308,5 @@
 
    1  CONTINUE ! Matsuno Forward step begins here
-
+      !write(*,*) 'leapfrog 298: itau=',itau
       jD_cur = jD_ref + day_ini - day_ref +                             &
      &          itau/day_step
@@ -306,4 +318,7 @@
       endif
 
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 321')
+        endif !if (ok_iso_verif) then
 
 #ifdef CPP_IOIPSL
@@ -384,5 +399,15 @@
 cym      call minmax(ijp1llm,q(:,:,3),zqmin,zqmax)
 
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 400')
+        endif !if (ok_iso_verif) then
+
    2  CONTINUE ! Matsuno backward or leapfrog step begins here
+
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 402')
+        endif !if (ok_iso_verif) then
 
 c$OMP MASTER
@@ -455,4 +480,8 @@
 c$OMP END MASTER      
 
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 471')
+        endif !if (ok_iso_verif) then
 
 !ym  PAS D'AJUSTEMENT POUR LE MOMENT     
@@ -574,4 +603,7 @@
      
       
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 589')
+        endif !if (ok_iso_verif) then
       
 c-----------------------------------------------------------------------
@@ -635,5 +667,8 @@
       ! compute geopotential phi()
       CALL geopot_loc  ( ip1jmp1, teta  , pk , pks,  phis  , phi   )
-
+        
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 651')
+        endif !if (ok_iso_verif) then
       
       call VTb(VTcaldyn)
@@ -644,4 +679,5 @@
 !      CALL FTRACE_REGION_BEGIN("caldyn")
       time = jD_cur + jH_cur 
+
       CALL caldyn_loc 
      $  ( itau,ucov,vcov,teta,ps,masse,pk,pkf,phis ,
@@ -670,10 +706,21 @@
 c   -------------------------------------------------------------
 
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,
+     &           'leapfrog 686: avant caladvtrac')
+        endif !if (ok_iso_verif) then
       
       IF( forward. OR . leapf )  THEN
 ! Ehouarn: NB: fields sent to advtrac are those at the beginning of the time step
+        !write(*,*) 'leapfrog 679: avant CALL caladvtrac_loc'
          CALL caladvtrac_loc(q,pbaru,pbarv,
      *        p, masse, dq,  teta,
      .        flxw,pk, iapptrac)
+
+         !write(*,*) 'leapfrog 719'
+         if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,
+     &           'leapfrog 698: apres caladvtrac')
+         endif !if (ok_iso_verif) then
 
 !      do j=1,nqtot
@@ -708,8 +755,19 @@
 !       CALL FTRACE_REGION_BEGIN("integrd")
 
-       CALL integrd_loc ( 2,vcovm1,ucovm1,tetam1,psm1,massem1 ,
+       !write(*,*) 'leapfrog 720' 
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 756')
+        endif !if (ok_iso_verif) then
+
+       ! CRisi: pourquoi aller jusqu'à 2 et non pas jusqu'à nqtot?? 
+       CALL integrd_loc ( nqtot,vcovm1,ucovm1,tetam1,psm1,massem1 ,
      $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis)
 !     $              finvmaold                                    )
 
+       !write(*,*) 'leapfrog 724'       
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 762')
+        endif !if (ok_iso_verif) then 
+ 
 !       CALL FTRACE_REGION_END("integrd")
 c$OMP BARRIER
@@ -724,4 +782,9 @@
       call WriteField_u('ps_int',ps)
 #endif    
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 775')
+        endif !if (ok_iso_verif) then
+
 c      do j=1,nqtot
 c        call WriteField_p('q'//trim(int2str(j)),
@@ -1082,4 +1145,9 @@
        ENDIF ! of IF( apphys )
 
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1132')
+        endif !if (ok_iso_verif) then
+        !write(*,*) 'leapfrog 1134: iflag_phys=',iflag_phys
+
       IF(iflag_phys.EQ.2) THEN ! "Newtonian" case
 c$OMP MASTER
@@ -1146,9 +1214,12 @@
 
 cc$OMP END PARALLEL
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1196')
+        endif !if (ok_iso_verif) then
 
 c-----------------------------------------------------------------------
 c   dissipation horizontale et verticale  des petites echelles:
 c   ----------------------------------------------------------
-
+      !write(*,*) 'leapfrog 1163: apdiss=',apdiss
       IF(apdiss) THEN
       
@@ -1379,5 +1450,9 @@
 c                call abort_gcm(modname,abort_message,0)
 c              ENDIF
-        
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1430')
+        endif !if (ok_iso_verif) then     
+ 
 c   ********************************************************************
 c   ********************************************************************
@@ -1455,4 +1530,8 @@
       ENDIF
       
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1509')
+        endif !if (ok_iso_verif) then
+
       IF ( .NOT.purmats ) THEN
 c       ........................................................
@@ -1526,4 +1605,8 @@
             ENDIF
 
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1584')
+        endif !if (ok_iso_verif) then
+
 c-----------------------------------------------------------------------
 c   ecriture de la bande histoire:
@@ -1562,4 +1645,8 @@
             ENDIF ! of IF (itau.EQ.itaufin)
 
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1624')
+        endif !if (ok_iso_verif) then
+
 c-----------------------------------------------------------------------
 c   gestion de l'integration temporelle:
@@ -1596,4 +1683,9 @@
 
       ELSE ! of IF (.not.purmats)
+
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1664')
+        endif !if (ok_iso_verif) then
 
 c       ........................................................
@@ -1631,4 +1723,9 @@
 
             ELSE ! of IF(forward) i.e. backward step
+
+              
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1698')
+        endif !if (ok_iso_verif) then  
 
               IF(MOD(itau,iperiod).EQ.0 .OR. itau.EQ.itaufin) THEN
@@ -1683,4 +1780,9 @@
             ENDIF ! of IF (forward)
 
+
+        if (ok_iso_verif) then
+           call check_isotopes(q,ijb_u,ije_u,'leapfrog 1750')
+        endif !if (ok_iso_verif) then
+
       END IF ! of IF(.not.purmats)
 c$OMP MASTER
